Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Core.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Core.cpp	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Core.cpp	(revision 145)
@@ -25,6 +25,7 @@
    morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-   morpheo::behavioural::core::Parameters * param,
-   morpheo::behavioural::Tusage_t usage
+   Parameters * param,
+   morpheo::behavioural::Tusage_t           usage// ,
+   // morpheo::behavioural::Function_pointer * function_pointer
    ):
     _name              (name)
@@ -48,4 +49,5 @@
 		param_statistics
 #endif
+                // function_pointer
 		);
 
@@ -72,4 +74,7 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
+
+        // if (function_pointer==NULL)
+        //   {
 	log_printf(INFO,Core,FUNCTION,_("<%s> Method - transition"),_name.c_str());
 
@@ -77,8 +82,14 @@
 	dont_initialize ();
 	sensitive << (*(in_CLOCK)).pos();
-	
+
 # ifdef SYSTEMCASS_SPECIFIC
 	// List dependency information
 # endif    
+        //   }
+        // else
+        //   {
+        //     function_pointer->transition_add(static_cast<f_t>(&morpheo::behavioural::core::Core::transition));
+        //   }
+
       }
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Core_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Core_allocation.cpp	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Core_allocation.cpp	(revision 145)
@@ -24,4 +24,10 @@
    void
 #endif
+
+// #ifdef STATISTICS
+//    morpheo::behavioural::Parameters_Statistics * param_statistics,
+// #endif
+//    morpheo::behavioural::Function_pointer      * function_pointer
+
    )
   {
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp	(revision 145)
@@ -248,5 +248,6 @@
 
   Tpriority_t             dispatch_priority                             ,
-  Tload_balancing_t       dispatch_load_balancing                       
+  Tload_balancing_t       dispatch_load_balancing                       ,
+  bool                    is_toplevel
                         )
   {
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Comparator/SelfTest/configuration/configuration.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Comparator/SelfTest/configuration/configuration.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Comparator/SelfTest/configuration/configuration.gen	(revision 145)
@@ -0,0 +1,4 @@
+Comparator
+32      32      *2      # size_data
+0       1       +1      # is_signed
+0       5       +1      # type
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/configuration/configuration.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/configuration/configuration.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/configuration/configuration.gen	(revision 145)
@@ -0,0 +1,3 @@
+Counter
+2	31	*2	# size_data
+1	6	+1	# nb_port
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Divider/SelfTest/configuration/configuration.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Divider/SelfTest/configuration/configuration.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Divider/SelfTest/configuration/configuration.gen	(revision 145)
@@ -0,0 +1,1 @@
+Divider
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Multiplier/SelfTest/configuration/configuration.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Multiplier/SelfTest/configuration/configuration.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Multiplier/SelfTest/configuration/configuration.gen	(revision 145)
@@ -0,0 +1,5 @@
+Multiplier
+16       32     *2      #size_data
+0        1      +1      #sign
+6       32      *3      #latency
+1        1      +1      #delay
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/configuration/config_mono_gpr.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/configuration/config_mono_gpr.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/configuration/config_mono_gpr.gen	(revision 145)
@@ -0,0 +1,6 @@
+Priority
+0	1	+1	# priority      
+0	1	+1	# load_balancing
+1	1	+1	# nb_grp                 
+1	16	*4	# nb_elt         [0] [nb_grp]
+1	1	+1	# nb_grp_select          
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/configuration/config_multi_gpr.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/configuration/config_multi_gpr.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/configuration/config_multi_gpr.gen	(revision 145)
@@ -0,0 +1,9 @@
+Priority
+0	1	+1	# priority      
+0	1	+1	# load_balancing
+4	4	+1	# nb_grp                 
+4	4	*4	# nb_elt         [0] [nb_grp]
+1	1	*4	# nb_elt         [1] [nb_grp]
+16	16	*4	# nb_elt         [2] [nb_grp]
+2	2	*4	# nb_elt         [3] [nb_grp]
+1	4	+1	# nb_grp_select          
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_min.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_min.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_min.gen	(revision 145)
@@ -0,0 +1,6 @@
+Queue
+1	1 	*2	#_size_queue	
+1	1	*2	#_size_data 
+0  	1  	+1	#_nb_port_slot
+0       0       +1      #_have_port_write
+0       0       +1      #_have_port_read
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_size_queue_log2.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_size_queue_log2.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_size_queue_log2.gen	(revision 145)
@@ -0,0 +1,6 @@
+Queue
+1	32 	*2	#_size_queue	
+32	32	*2	#_size_data 
+0  	0  	*2	#_nb_port_slot
+1       1       +1      #_have_port_write
+1       1       +1      #_have_port_read
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_size_queue_no_log2.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_size_queue_no_log2.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_size_queue_no_log2.gen	(revision 145)
@@ -0,0 +1,6 @@
+Queue
+3	256	*4	#_size_queue	
+32	32	*2	#_size_data 
+0  	0  	*2	#_nb_port_slot
+1       1       +1      #_have_port_write
+1       1       +1      #_have_port_read
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_slot_out_size_queue_log2.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_slot_out_size_queue_log2.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_slot_out_size_queue_log2.gen	(revision 145)
@@ -0,0 +1,6 @@
+Queue
+8	8 	*2	#_size_queue	
+32	32	*2	#_size_data 
+1  	8  	*2	#_nb_port_slot
+1       1       +1      #_have_port_write
+1       1       +1      #_have_port_read
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_slot_out_size_queue_no_log2.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_slot_out_size_queue_no_log2.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/configuration/config_slot_out_size_queue_no_log2.gen	(revision 145)
@@ -0,0 +1,6 @@
+Queue
+11	11	*4	#_size_queue	
+32	32	*2	#_size_data 
+1  	8  	*2	#_nb_port_slot
+1       1       +1      #_have_port_write
+1       1       +1      #_have_port_read
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/Makefile	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/Makefile	(revision 145)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= .
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libRegisterFile_Internal_Banked.a
+
+
+#-----[ include ]------------------------------------------
+
+all				: $(LIBRARY_NEED)
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/Makefile.defs
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/Makefile.defs	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/Makefile.defs	(revision 145)
@@ -0,0 +1,13 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+ENTITY                          = RegisterFile_Internal_Banked
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/Makefile.deps	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/Makefile.deps	(revision 145)
@@ -0,0 +1,37 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+RegisterFile_Internal_Banked			= yes
+
+ifndef Behavioural
+include 					$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
+
+#-----[ Library ]------------------------------------------
+
+RegisterFile_Internal_Banked_LIBRARY		= 	-lRegisterFile_Internal_Banked		\
+							$(Behavioural_LIBRARY)	
+
+#-----[ Rules ]--------------------------------------------
+
+RegisterFile_Internal_Banked_library_only	:
+						@\
+						$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked --makefile=Makefile;
+	
+RegisterFile_Internal_Banked_library_clean_only	:
+						@\
+						$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked --makefile=Makefile clean;
+
+RegisterFile_Internal_Banked_library			: RegisterFile_Internal_Banked_library_only
+						@\
+						$(MAKE)  Behavioural_library;
+	
+RegisterFile_Internal_Banked_library_clean	: RegisterFile_Internal_Banked_library_clean_only
+						@\
+						$(MAKE)  Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/Makefile	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/Makefile	(revision 145)
@@ -0,0 +1,32 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT                   = ../
+include                         $(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(RegisterFile_Internal_Banked_LIBRARY)
+
+DIR_LIBRARY			= $(RegisterFile_Internal_Banked_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: RegisterFile_Internal_Banked_library
+
+library_clean			: RegisterFile_Internal_Banked_library_clean
+
+local_clean			:
+
+include                         ../Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/configuration/config_read.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/configuration/config_read.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/configuration/config_read.gen	(revision 145)
@@ -0,0 +1,5 @@
+RegisterFile_Internal_Banked
+1	8 	*2	# nb_port_read
+1	1	*2	# nb_port_write
+512 	512	*2	# nb_word
+32	32	*2	# size_word
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/configuration/config_size.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/configuration/config_size.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/configuration/config_size.gen	(revision 145)
@@ -0,0 +1,5 @@
+RegisterFile_Internal_Banked
+4	4 	*2	# nb_port_read
+2	2	*2	# nb_port_write
+1   	128	*2	# nb_word
+32	32	*2	# size_word
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/configuration/config_write.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/configuration/config_write.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/configuration/config_write.gen	(revision 145)
@@ -0,0 +1,5 @@
+RegisterFile_Internal_Banked
+1	1 	*2	# nb_port_read
+2	8	*2	# nb_port_write
+512	512	*2	# nb_word
+32	32	*2	# size_word
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/include/test.h	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/include/test.h	(revision 145)
@@ -0,0 +1,27 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#include <string>
+#include <iostream>
+#include <sys/time.h>
+#include "Common/include/Time.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/include/RegisterFile_Internal_Banked.h"
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::generic;
+using namespace morpheo::behavioural::generic::registerfile;
+using namespace morpheo::behavioural::generic::registerfile::registerfile_internal_banked;
+
+void test   (string name,
+	     morpheo::behavioural::generic::registerfile::registerfile_internal_banked::Parameters * param);
+
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/mkf.info
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/mkf.info	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/mkf.info	(revision 145)
@@ -0,0 +1,21 @@
+
+# state_0
+target_dep	all	state_0.ngc
+target_dep	state_0.ngc	state_0.prj
+target_dep	state_0.prj	state_0_Pack.vhdl state_0.vhdl
+
+# state_1
+target_dep	all	state_1.ngc
+target_dep	state_1.ngc	state_1.prj
+target_dep	state_1.prj	state_1_Pack.vhdl state_1.vhdl
+
+# state_2
+target_dep	all	state_2.ngc
+target_dep	state_2.ngc	state_2.prj
+target_dep	state_2.prj	state_2_Pack.vhdl state_2.vhdl
+
+# state_3
+target_dep	all	state_3.ngc
+target_dep	state_3.ngc	state_3.prj
+target_dep	state_3.prj	state_3_Pack.vhdl state_3.vhdl
+
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/src/main.cpp	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/src/main.cpp	(revision 145)
@@ -0,0 +1,47 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/include/test.h"
+
+#define NB_PARAMS 4
+
+void usage (string exec)
+{
+  cerr << "<Usage> " << exec << " name_instance list_params" << endl
+       << "list_params is :" << endl
+       << " - nb_port_read       (unsigned int)" << endl
+       << " - nb_port_write      (unsigned int)" << endl
+       << " - nb_word            (unsigned int)" << endl
+       << " - size_word          (unsigned int)" << endl;
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  if (argc <  2+NB_PARAMS)
+    usage (argv[0]);
+
+  const string   name               = argv[1];
+  const uint32_t nb_port_read       = atoi(argv[2]);
+  const uint32_t nb_port_write      = atoi(argv[3]);
+  const uint32_t nb_word            = atoi(argv[4]);
+  const uint32_t size_word          = atoi(argv[5]);
+  
+  morpheo::behavioural::generic::registerfile::registerfile_internal_banked::Parameters * param = new morpheo::behavioural::generic::registerfile::registerfile_internal_banked::Parameters
+    (nb_port_read ,
+     nb_port_write,
+     nb_word      ,
+     size_word    );
+  
+  test (name,param);
+
+  return (EXIT_SUCCESS);
+}
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/src/test.cpp	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/src/test.cpp	(revision 145)
@@ -0,0 +1,244 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test
+ */
+
+#define NB_ITERATION 1
+#define CYCLE_MAX    100000*NB_ITERATION
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest/include/test.h"
+#include "Common/include/Test.h"
+
+void test (string name,
+	   morpheo::behavioural::generic::registerfile::registerfile_internal_banked::Parameters * _param)
+{
+  cout << "<" << name << "> : Simulation SystemC" << endl;
+
+  try 
+    {
+      cout << _param->print(1);
+      _param->test();
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      cout << "<" << name << "> : " <<  error.what ();
+      return;
+    }
+  catch (...)
+    {
+      cerr << "<" << name << "> : This test must generate a error" << endl;
+      exit (EXIT_FAILURE);
+    }
+
+  _model.set_model(MODEL_SYSTEMC,true);
+
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
+#ifdef STATISTICS
+  morpheo::behavioural::Parameters_Statistics * _param_stat = new morpheo::behavioural::Parameters_Statistics (5,100);
+#endif
+  RegisterFile_Internal_Banked * registerfile = new RegisterFile_Internal_Banked 
+    (name.c_str()
+#ifdef STATISTICS
+     ,_param_stat
+#endif
+     ,_param
+     ,_usage);
+  
+#ifdef SYSTEMC
+  /*********************************************************************
+   * Déclarations des signaux
+   *********************************************************************/
+  sc_clock                                 CLOCK ("clock", 1.0, 0.5);
+  sc_signal<Tcontrol_t>                    NRESET;
+  
+  sc_signal<Tcontrol_t>                    READ_VAL      [_param->_nb_port_read];
+  sc_signal<Tcontrol_t>                    READ_ACK      [_param->_nb_port_read];
+  sc_signal<Taddress_t>                    READ_ADDRESS  [_param->_nb_port_read];
+  sc_signal<Tdata_t>                       READ_DATA     [_param->_nb_port_read];
+
+  sc_signal<Tcontrol_t>                    WRITE_VAL     [_param->_nb_port_write];
+  sc_signal<Tcontrol_t>                    WRITE_ACK     [_param->_nb_port_write];
+  sc_signal<Taddress_t>                    WRITE_ADDRESS [_param->_nb_port_write];
+  sc_signal<Tdata_t>                       WRITE_DATA    [_param->_nb_port_write];
+
+  /********************************************************
+   * Instanciation
+   ********************************************************/
+  
+  cout << "<" << name << "> Instanciation of registerfile" << endl;
+  
+  (*(registerfile->in_CLOCK))        (CLOCK);
+  (*(registerfile->in_NRESET))       (NRESET);
+
+  for (uint32_t i=0; i<_param->_nb_port_read; i++)
+    {
+      (*(registerfile-> in_READ_VAL      [i]))        (READ_VAL      [i]);
+      (*(registerfile->out_READ_ACK      [i]))        (READ_ACK      [i]);
+      if (_param->_have_port_address)
+      (*(registerfile-> in_READ_ADDRESS  [i]))        (READ_ADDRESS  [i]);
+      (*(registerfile->out_READ_DATA     [i]))        (READ_DATA     [i]);
+    }
+  for (uint32_t i=0; i<_param->_nb_port_write; i++)
+    {
+      (*(registerfile-> in_WRITE_VAL     [i]))        (WRITE_VAL     [i]);
+      (*(registerfile->out_WRITE_ACK     [i]))        (WRITE_ACK     [i]);
+      if (_param->_have_port_address)
+      (*(registerfile-> in_WRITE_ADDRESS [i]))        (WRITE_ADDRESS [i]);
+      (*(registerfile-> in_WRITE_DATA    [i]))        (WRITE_DATA    [i]);
+    }
+  
+  cout << "<" << name << "> Start Simulation ............" << endl;
+  Time * _time = new Time();
+
+  /********************************************************
+   * Simulation - Begin
+   ********************************************************/
+
+  // Initialisation
+
+  SC_START(0);
+  
+  for (uint32_t i=0; i<_param->_nb_port_write; i++)
+    WRITE_VAL [i] .write (0);
+  for (uint32_t i=0; i<_param->_nb_port_read; i++)
+    READ_VAL  [i] .write (0);
+
+  NRESET.write(0);
+
+  SC_START(5);
+
+  NRESET.write(1);
+
+  for (uint32_t i=0; i<_param->_nb_port_write; i++)
+    TEST(Tcontrol_t,WRITE_ACK [i],1);
+  for (uint32_t i=0; i<_param->_nb_port_read; i++)
+    TEST(Tcontrol_t,READ_ACK  [i],1);
+
+  for (uint32_t nb_iteration=0; nb_iteration < NB_ITERATION; nb_iteration ++)
+    {
+      cout << "<" << name << "> 1) Write the RegisterFile (no read)" << endl;
+
+      // random init
+      uint32_t grain = 0;
+      //uint32_t grain = static_cast<uint32_t>(time(NULL));
+      
+      srand(grain);
+
+      Tdata_t tab [_param->_nb_word];
+      
+      for (uint32_t i=0; i<_param->_nb_word; i++)
+	tab[i]= rand()%(1<<(_param->_size_word-1));
+      
+      Taddress_t address_next = 0;
+      Taddress_t nb_ack = 0;
+      
+      while (nb_ack < _param->_nb_word)
+	{
+          
+	  cout << "cycle : " << static_cast<uint32_t> (simulation_cycle()) << endl;
+
+	  for (uint32_t num_port=0; num_port < _param->_nb_port_write; num_port ++)
+	    {
+	      if ((address_next < _param->_nb_word) and
+		  (WRITE_VAL [num_port].read() == 0))
+		{
+		  cout << "(" << num_port << ") [" << address_next << "] <= " << tab[address_next] << endl;
+		  
+		  WRITE_VAL     [num_port] .write(1);
+		  WRITE_DATA    [num_port] .write(tab[address_next]);
+		  WRITE_ADDRESS [num_port] .write(address_next++);
+		  
+		  // Address can be not a multiple of nb_port_write
+		  if (address_next >= _param->_nb_word)
+		    break;
+		}
+	    }
+
+  
+	  SC_START(1);
+
+	  // reset write_val port
+	  for (uint32_t num_port=0; num_port < _param->_nb_port_write; num_port ++)
+	    {
+	      if ((WRITE_ACK [num_port].read() == 1) and
+		  (WRITE_VAL [num_port].read() == 1))
+		{
+		  WRITE_VAL  [num_port] .write(0);
+		  nb_ack ++;
+		}
+	    }
+
+// 	  SC_START(0);
+	}
+      
+      address_next = 0;
+      nb_ack       = 0;
+
+      cout << "<" << name << "> 2) Read the RegisterFile (no write)" << endl;
+      
+      Tdata_t read_address       [_param->_nb_port_read];
+
+      while (nb_ack < _param->_nb_word)
+	{
+	  cout << "cycle : " << static_cast<uint32_t> (simulation_cycle()) << endl;
+	  
+	  for (uint32_t num_port=0; num_port < _param->_nb_port_read; num_port ++)
+	    {
+	      if ((address_next < _param->_nb_word) and
+		  (READ_VAL [num_port].read() == 0))
+		{
+		  read_address [num_port] = address_next++;
+
+		  READ_VAL     [num_port].write(1);
+		  READ_ADDRESS [num_port].write(read_address [num_port]);
+
+		  if (address_next >= _param->_nb_word)
+		    break;
+		}
+	    }
+
+
+	  SC_START(1);
+
+	  // reset write_val port
+	  for (uint32_t num_port=0; num_port < _param->_nb_port_read; num_port ++)
+	    {
+	      if ((READ_ACK [num_port].read() == 1) and
+		  (READ_VAL [num_port].read() == 1))
+		{
+		  READ_VAL  [num_port] .write(0);
+
+		  cout << "(" << num_port << ") [" << read_address [num_port] << "] => " << READ_DATA [num_port].read() << endl;
+
+		  TEST(Tdata_t,READ_DATA [num_port].read(), tab[read_address [num_port]]);
+		  nb_ack ++;
+		}
+	    }
+
+// 	  SC_START(0);
+	}
+    }
+
+  /********************************************************
+   * Simulation - End
+   ********************************************************/
+
+  TEST_STR(bool,true,true, "End of Simulation");
+  delete _time;
+  cout << "<" << name << "> ............ Stop Simulation" << endl;
+
+#endif
+
+  delete registerfile;
+}
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/doc/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/doc/Makefile	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/doc/Makefile	(revision 145)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/include/Parameters.h	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Internal_Banked/include/Parameters.h	(revision 145)
@@ -0,0 +1,62 @@
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_internal_banked_Parameters_h
+#define morpheo_behavioural_generic_registerfile_registerfile_internal_banked_Parameters_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Debug.h"
+#include "Behavioural/include/Parameters.h"
+#include <math.h>
+
+namespace morpheo                    {
+namespace behavioural                {
+namespace generic                    {
+namespace registerfile               {
+namespace registerfile_internal_banked    {
+
+#define PTR_IS_REGFILE
+
+  class Parameters : public morpheo::behavioural::Parameters
+  {
+  public :       uint32_t    _nb_port_read ;
+  public :       uint32_t    _nb_port_write;
+  public :       uint32_t    _nb_word      ;
+  public :       uint32_t    _size_word    ;
+  public :       std::string _init_value   ;
+
+  public : const uint32_t    _nb_internal_port_read ;
+  public : const uint32_t    _nb_internal_port_write;
+
+  public :       uint32_t    _size_address;
+  public :       uint32_t    _size_ptr_write;
+  public :       bool        _have_port_address;
+  public :       bool        _have_init_value;
+
+  public : Parameters (uint32_t    nb_port_read ,
+		       uint32_t    nb_port_write,
+		       uint32_t    nb_word      ,
+		       uint32_t    size_word    ,
+                       std::string init_value="");
+//   public : Parameters (Parameters & param) ;
+  public : ~Parameters () ;
+
+  public :        void            copy       (void);
+
+  public :        Parameters_test msg_error  (void);
+
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::generic::registerfile::registerfile_internal_banked::Parameters & x);
+  };
+
+}; // end namespace registerfile_internal_banked
+}; // end namespace registerfile 
+}; // end namespace generic
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+
+#endif
